package gomod

import (
//	"io"
	"fmt"
	"net/http"
	"path/filepath"
	"encoding/json"
	"payease_iccdelivery/models"
	"payease_iccdelivery/utils"
)

func DeliveryRequest(w http.ResponseWriter, r *http.Request) {
	//接口地址
	 apiurl := "https://apis.5upay.com/icc/delivery"
	 //pfx私钥
	 privatepfxpath, pfxerr := filepath.Abs("src/payease_iccdelivery/package/client.pfx")
	 if pfxerr != nil {  
	    fmt.Println("pfxerr:", pfxerr)  
	 } 
	 pfxpwd := "123456"
     //cer公钥
	 publiccerpath, cererr := filepath.Abs("src/payease_iccdelivery/package/payease.cer")
	 if cererr != nil {  
	    fmt.Println("cererr:", cererr)  
	 } 
     var aesKeyValue string  = utils.GetRandomString(16)
	 r.ParseForm()
	 var payorder models.OrderDelivery
	 payorder.MerchantId = utils.IsNull(r.Form["merchantId"])
	 payorder.RequestId = utils.IsNull(r.Form["requestId"])
     payorder.DeliveryId = utils.IsNull(r.Form["deliveryId"])
     
	 //把订单对象数据转JSON字符串
	 orderdata, err := json.Marshal(payorder)  
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}
	//fmt.Println("orderdata:", string(orderdata))  
	sortdata, oerr := utils.GetMapSortJson(string(orderdata))
	if oerr != nil {
        fmt.Println("oerr:", oerr)
    }
	//fmt.Println("sortdata:", sortdata) 
	hm := utils.Sha1(sortdata)
	hmac,err := utils.Sign(hm,privatepfxpath,pfxpwd)
	if err != nil {
        fmt.Println("err:", err)
    } 
	payorder.Hmac = hmac
	orderjson, err := json.Marshal(payorder)  
	if err != nil {  
	    fmt.Printf(err.Error())  
	    return  
	}
	encryptKey,enerr := utils.PublicEncrypt(aesKeyValue, publiccerpath)
	if enerr != nil {
        fmt.Println("err:", enerr)
    } 
	aesdata,aeserro := utils.AesECBEncrypt(string(orderjson), aesKeyValue)
	//fmt.Println("aesdata:", aesdata)
	if aeserro != nil {
        fmt.Println("err:", aeserro)
    } 
	response, rperr := utils.Post(apiurl,encryptKey,payorder.MerchantId,payorder.RequestId,aesdata,privatepfxpath,pfxpwd)
	if rperr != nil {
        fmt.Println("rperr:", rperr)
    } 
	var orderback models.OrderDeliveryBack
    json.Unmarshal([]byte(response), &orderback)
    rhmac := orderback.Hmac
    //fmt.Println("rhmac:", rhmac)
    if 	rhmac != ""{
    	sortdeldata, oerr := utils.GetDelJson(string(response),"hmac")
		if oerr != nil {
	        fmt.Println("oerr:", oerr)
	    } 
		signhm := utils.Sha1(sortdeldata)
    	verr := utils.VerifySign(signhm ,publiccerpath,rhmac)
    	if verr == nil {
    		status := orderback.Status
    		if status == "SUCCESS"{
    			fmt.Println("成功:", status)
    			fmt.Println("response:", response)
    			fmt.Fprintf(w,"成功:" + status)
    			fmt.Fprintf(w, "\n" + response)
    		}else{
    			fmt.Println("失败:", status)
    			fmt.Fprintf(w,"失败:"+status)
    		}
    	}else{
	    	fmt.Println("verr:", verr)
	    	fmt.Fprintf(w,"验签异常!")
    	}
    }else{
    	fmt.Println("response:", response)
    	fmt.Fprintf(w, response)
    }
}