package utils

import (
	"fmt"
	"sort"
	"time"
	//"reflect"
	"strconv"
	"math/rand"
	"encoding/json"
)

// 随机生成指定位数的大写字母和数字的组合
func  GetRandomString(l int) string {
	str := "0123456789abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ"
	bytes := []byte(str)
	result := []byte{}
	r := rand.New(rand.NewSource(time.Now().UnixNano()))
	for i := 0; i < l; i++ {
		result = append(result, bytes[r.Intn(len(bytes))])
	}
	return string(result)
}
//根据JSON字符串返回以键值存在的数组
func getMapFromJson(jsonstr string) map[string]interface{} {
    var jsonBody = []byte(jsonstr)
    var dat map[string]interface{}
	if err := json.Unmarshal(jsonBody, &dat); err == nil {
	    return dat
	}else{
		return nil
	}
}
//根据JSON字符串进行排序后返回顺序拼接字符串
func GetMapSortJson(jsonstr string) (string, error){
	map2 := getMapFromJson(jsonstr)
	var recResult string
	var erro error
    //1.定义一个slice
    s1 := make([]string, 0, len(map2))
    //2.遍历map获取key-->s1中
    for key := range map2 {
        s1 = append(s1, key)
    }
    //3.给s1进行排序
    //使用sort包下的方法直接排序，不用自己写冒泡了。
    sort.Strings(s1)
    //4. 遍历s1，map
    for _, k := range s1 { // 先下标，再数值
        switch value := map2[k].(type) {
        case nil:
            fmt.Println(k, "is nil", "null")
        case int:
			recResult = recResult + strconv.Itoa(value)+"#"
		case float64:
			recResult = recResult + strconv.FormatFloat(value, 'f', -1, 64)+"#"
        case string:
			if value != ""{
				recResult = recResult + value+"#"  
			}
		case bool:
			recResult = recResult +strconv.FormatBool(value)+"#"
        case []interface{}:
            for _, u := range value {
	            	//fmt.Println("utype:", reflect.TypeOf(u))	
	            	if _, ok := u.(map[string]interface {}); ok != true {
		            	recResult = recResult + u.(string) +"#"
		            }else{
		            	b, berror := json.Marshal(u)
					    if berror != nil {
					        erro = berror
					    }			
						rec,erro2 := GetMapSortJson(string(b))
					    if erro2 != nil {
					        erro = erro2
					    }
			            recResult = recResult + rec  
		            }
				}
        case map[string]interface{}:
	        b, berror := json.Marshal(value)
		    if berror != nil {
		        fmt.Print("berror:", berror)
		    }
		    rec,erro2 := GetMapSortJson(string(b))
			if erro2 != nil {
				erro = erro2
			}
            recResult = recResult + rec  
        default:
            va := value.(string)
			if va != ""{
				recResult = recResult + va+"#"
			}
        }
	}    
    return recResult,erro
}
//根据JSON字符串和键值删除后进行排序后返回顺序拼接字符串
func GetDelJson(jsonstr string,delname string) (string, error){
	map2 := getMapFromJson(jsonstr)
	var erro error
	delete(map2, delname)
	b, berror := json.Marshal(map2)
	if berror != nil {
		erro = berror
	}
	sortdata, oerr := GetMapSortJson(string(b))
	if oerr != nil {
		erro = oerr
	}
	return sortdata,erro
}
//读取测试数据的文件内容
func IsNull(arr []string) string {
    if len(arr) != 0 {
        return arr[0]
    }else {
        return "error" 
    }
}